/*  www.sgm.siedlce.pl

prosty test detekcji 2 dowolnych kanalow PPM (kan2, kan3),
suma (zewnetrzna) kan2 i kan3 jako warunek rozpoczecia
dekodowania, sprawdzone z odbiornikami Fr-Sky oraz Jeti Rex5+,
powinno dzialac z dowolnym odbiornikiem i dowolnymi dwoma kanalami;

*/

byte PinRx1 = 12;  // suma kan1+kan2 podlaczony do Pin12
byte PinRx2 = 10;  // sygnal kan2 podlaczony do Pin10
byte PinRx3 = 8;   // sygnal kan3 podlaczony do Pin8
   
int PPM2 = 0;     // zmienna na dlugosc impulsu kan2
int PPM3 = 0;     // zmienna na dlugosc impulsu kan3
byte Rx1 = 0;     // zmienna na odczyt sumy kan2 i kan3
byte k=0;         // zmienna do odczytu kanału co drugi raz

int Licz = 0;       // zmienne pozwalajace drukowac
int LiczMax = 20;   // co 20 impuls PPM1

void setup()             // inicjalizacja programu
{
  pinMode(PinRx1,INPUT); // ustaw PinRx1 jako wejscie
  pinMode(PinRx2,INPUT); // ustaw PinRx2 jako wejscie
                         // (*) nieobowiazkowe dla polecenia pulseIn
  pinMode(PinRx3,INPUT); // ustaw PinRx3 jako wejscie
                         // (*) nieobowiazkowe dla polecenia pulseIn
  Serial.begin(57600);   // ustaw predkosc transmisji
                         // dla danych do terminala
}

void loop() {            // glowna petla programu 
 
  Rx1=digitalRead(PinRx1);  // czytaj kan2 lub kan3
                            // jesli zaden z nich nie jest wysoki 
  if (Rx1==0)               // rozpocznij detekcje
  {
   k += 1;
   if (k==1)                // sprawdzaj zmienną k i czytaj co drugi raz
   {                        // wejscia PinRx2, PinRx3
    PPM2=pulseIn(PinRx2,HIGH);   
   }
   else
   {
   PPM3=pulseIn(PinRx3,HIGH);   
   k=0;  
   }  
  }

                            // wyswietlanie zmierzonych wartosci
                            // na terminalu
                            
 Licz += 1;                 // zwieksz licznik impulsow o 1 
 if (Licz>LiczMax) {        // drukuj wartosc co n-ty impuls

  Serial.print(PPM2);
  Serial.print(";  ");
  Serial.print(PPM3);
  Serial.println(";  ");
  
  Licz = 0;
 }
 
}
